<?php

namespace App\Models;

use EloquentFilter\Filterable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Approval extends Model
{
    use HasFactory, SoftDeletes, Filterable;

    protected $fillable = [
        'approval_flow_id',
        'object_type',
        'object_id',
        'node_level',
        'users',
        'remark',
        'created_by',
        'status',
    ];

    public function approvalFlow()
    {
        return $this->belongsTo(ApprovalFlow::class)->withTrashed();
    }

    public function createdBy()
    {
        return $this->belongsTo(User::class, 'created_by');
    }
}
